//+------------------------------------------------------------------+
//|                                                     CSV Stat.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property show_inputs
#import "#_lib_FFT.ex4"
void realfastfouriertransform(double& a[], int tnn, bool inversefft);
#import

extern int     WinSize     = 20;
extern string  FileName    = "stat";
extern bool    EveryMonth  = true;
//extern bool    EveryYear  = false;
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
{
 int handle, BarLow, BarHigh, CurrMonth, PrevMonth;
//
   int tnn1=MathPow(2,4);//   -      
   double aa[];
   int N=ArrayResize(aa,tnn1);
   double sig;
   string OutStr;
   int iF;
//

 if(!EveryMonth)
 {
  handle=FileOpen(FileName + ".txt", FILE_CSV|FILE_WRITE,' ');
  if(handle<1)
  {
   Print("  ", GetLastError());
   return(false);
  }
//
    OutStr = "";
    for(iF=0; iF<=N-1; iF++)
    {
     OutStr = OutStr + " " + "aa[" + DoubleToStr(iF*2, 0)+"]" + " " + "aa["+DoubleToStr(iF*2+1, 0)+"]";
    }
//
  FileWrite(handle,
           "Bar", "BarTime",
           "High",
           "Low",
           "Close",
           "iRSI",
           "iMomentum",
           "iADX_MODE_MAIN",
           "iADX_MODE_PLUSDI",
           "iADX_MODE_MINUSDI",
           "iAC",
           "iAD",
           "iATR",
           "iAO",
           "iCCI",
           OutStr,
//           "ZigZag[0]",
//           "ZigZag[1]",
//           "ZigZag[2]",
           
           "iHigh", 
           "BUY", 
//           "Bar(High)", "Bar(High)Time",
           "iLow", 
           "SELL"
//           "Bar(Low)", "Bar(Low)Time"
          ); 
 }
 PrevMonth = 0;
 for(int i = Bars - 1 - WinSize; i >= 0; i--)
 {
  //CurrMonth = TimeYear(Time[i]) * 100+TimeMonth(Time[i]);
  CurrMonth = TimeYear(Time[i]);
  if(PrevMonth != CurrMonth && EveryMonth)
  {
   if(PrevMonth != 0) FileClose(handle);
   PrevMonth = CurrMonth;
   handle=FileOpen(FileName + "_" + CurrMonth + ".txt", FILE_CSV|FILE_WRITE,' ');
   if(handle<1)
   {
    Print(" ", GetLastError());
    return(false);
   }
//
    OutStr = "";
    for(iF=0; iF<=N-1; iF++)
    {
     OutStr = OutStr + " " + "aa[" + DoubleToStr(iF*2, 0)+"]" + " " + "aa["+DoubleToStr(iF*2+1, 0)+"]";
    }
//
  FileWrite(handle,
           "Bar", "BarTime",
           "High",
           "Low",
           "Close",
           "iRSI",
           "iMomentum",
           "iADX_MODE_MAIN",
           "iADX_MODE_PLUSDI",
           "iADX_MODE_MINUSDI",
           "iAC",
           "iAD",
           "iATR",
           "iAO",
           "iCCI",
           OutStr,
//           "ZigZag[0]",
//           "ZigZag[1]",
//           "ZigZag[2]",
           
           "iHigh", 
           "BUY", 
//           "Bar(High)", "Bar(High)Time",
           "iLow", 
           "SELL"
//           "Bar(Low)", "Bar(Low)Time"
          ); 
  }
  
  BarHigh = iHighest(NULL, 0, MODE_HIGH, WinSize, i - WinSize);
  BarLow = iLowest(NULL, 0, MODE_LOW, WinSize, i - WinSize);
//
    for(iF=0; iF<=N-1; iF++)
    {
      sig=Close[iF+i];
      aa[iF]=sig;
    }
    realfastfouriertransform(aa, tnn1, false); 
    InSigNormalize(aa); //  
   
    //---    
    OutStr = "";
    for(iF=0; iF<=N-1; iF++)
    {
     OutStr = OutStr + " " + DoubleToStr(aa[iF*2],8) + " " + DoubleToStr(aa[iF*2+1] ,8);
    }
//
  FileWrite(handle,
            TimeToStr(Time[i],TIME_DATE|TIME_SECONDS),
            High[i],
            Low[i],
            Close[i],
            iRSI(NULL, 0, 14, PRICE_MEDIAN, i),
            iMomentum(NULL, 0, 14, PRICE_MEDIAN, i),
            iADX(NULL, 0, 14, PRICE_MEDIAN, MODE_MAIN, i),
            iADX(NULL, 0, 14, PRICE_MEDIAN, MODE_PLUSDI, i),
            iADX(NULL, 0, 14, PRICE_MEDIAN, MODE_MINUSDI, i),
            iAC(NULL, 0, i),
            iAD(NULL, 0, i),
            iATR(NULL, 0, 14, i),
            iAO(NULL, 0, i),
            iCCI(NULL, 0, 14, PRICE_MEDIAN, i),
            OutStr,
//            iCustom(NULL, 0, "ZigZag", 12, 5, 3, 0, i),
//            iCustom(NULL, 0, "ZigZag", 12, 5, 3, 1, i),
//            iCustom(NULL, 0, "ZigZag", 12, 5, 3, 2, i),

            iHigh(NULL, 0, BarHigh), 
            iHigh(NULL, 0, BarHigh) - iClose(NULL, 0, i), 
//            TimeToStr(Time[BarHigh],TIME_DATE|TIME_SECONDS),
            iLow(NULL, 0, BarLow), 
            iLow(NULL, 0, BarLow) - iClose(NULL, 0, i)
//            TimeToStr(Time[BarLow],TIME_DATE|TIME_SECONDS)
           ); 
 }
   
//----
 if(!EveryMonth)  FileClose(handle);
 return(0);
}
//+------------------------------------------------------------------+

//--------------------------------------------------------------------+
void InSigNormalize(double& aa[])
{
   double sum_sqrt;
   int element_count=ArraySize(aa);
   sum_sqrt=0;
   for( int i=0; i<=element_count-1; i++)
   {
      sum_sqrt+=MathPow(aa[i],2);
   }
   sum_sqrt=MathSqrt(sum_sqrt);
   
   if (sum_sqrt!=0)
   {
      for( i=0; i<=element_count-1; i++)
      {
         aa[i]=aa[i]/sum_sqrt;
      }
   }
   return;
}
//---------------------------------------------------------------------+


